#include "peterson.h"


my_global_data_t *p;
int shmId = -1;



void getShm() {

    if ( 0 > (shmId = shmget(SHM_KEY, 
                             sizeof(my_global_data_t),
                             IPC_CREAT|0x1ff)) ) {
	perror("Problem at shmget()");
	exit(10);
    }

    if ( NULL == (p = shmat(shmId,NULL,0)) ) {
	perror("Problem at shmat()");
	exit(10);
    }

}


void input2Acc(int pid, int x) {

    int oldBal = p->u.balance;

    p->u.balance = oldBal + x;

    printf("PID %d inputs %d  old balance %d - new balance: %d\n",
	   pid,x,oldBal,p->u.balance);

}

void withdrawFromAccount(int pid, int sum) {

    int oldBal =  p->u.balance;

    sleep(1);

    if ( oldBal > sum ) {
	p->u.balance = oldBal - sum;
	printf("PID %d draws %d  old balance %d - new balance: %d\n",
               pid,sum,oldBal,p->u.balance);
    }
    else {
	printf("PID %d cannot draw %d - balance: %d\n",
	       pid,sum,p->u.balance);
    }

}


void enter_critical(int pid) {


    p->c.interested[pid] = 1;
    p->c.turn = pid;

    /* Busy waiting:
         interested[] verhindert, dass beide
         Prozesse gleichzeitig in die Critical
         Section kommen.
         turn verhindert einen Livelock,
         wo beide Prozesse gleichzeitig
         in der while-Schleife "verhungern"
     */
    while ( p->c.turn == pid &&  p->c.interested[1-pid] ) ;

}


void leave_critical(int pid) {

    p->c.interested[pid] = 0;

}




int main(int argc, char **argv) {

    int iCnt;
    int pid;
    int intoAcc;

    if ( argc < 3 ) {
	printf("Pid missing in command line - exit\n");
	exit(10);
    }

    pid = atoi(argv[1]);
    intoAcc = atoi(argv[2]);

    getShm();

    /* Initialisiere "dieser Prozess
       ist nicht interessiert" */
    p->c.interested[pid] = 0;

    enter_critical(pid);
    input2Acc(pid,intoAcc);
    leave_critical(pid);

    for (iCnt = 0; iCnt < MAX; iCnt++ ) {

	enter_critical(pid);

	withdrawFromAccount(pid, 100);

	leave_critical(pid);

    }

    exit(0);

}
